﻿using System;
using System.Collections.Generic;
using System.Text;

namespace Ogc.Filter.ComparisonOps
{
    public class PropertyIsBetween : ComparisonOp
    {
        IExpression value;
        IExpression lowerBoundary;
        IExpression upperBoundary;
        public PropertyIsBetween(IExpression value, IExpression lowerBoundary, IExpression upperBoundary)
        {
            this.value = value;
            this.lowerBoundary = lowerBoundary;
            this.upperBoundary = upperBoundary;
        }

        public override bool Test(IPropertyGetter getter)
        {
            IComparable c = value.Evaluate(getter) as IComparable;
            if (c != null)
                return c.CompareTo(lowerBoundary.Evaluate(getter)) >= 0
                    && c.CompareTo(upperBoundary.Evaluate(getter)) <= 0;
            return false;
        }
    }
}
