﻿using System;
using System.Collections.Generic;
using System.Text;

namespace Ogc.Filter.Expressions
{
    public class Function : IExpression
    {
        string name;
        IExpression[] args;

        public Function(string name,IExpression[] args)
        {
            this.name = name;
            this.args = args;
        }

        #region IExpression 成员

        public object Evaluate(IPropertyGetter getter)
        {
            object[] objs = new object[args.Length];
            for (int i = 0; i < args.Length; ++i)
                objs[i] = args[i].Evaluate(getter);
            return Functions.Call(name, objs);
        }

        #endregion
    }

    public static class Functions
    {
        internal static object Call(string name, object[] args)
        {
            if (name == "sin")
                return Math.Sin((double)args[0]);
            if (name == "cos")
                return Math.Cos((double)args[0]);
            throw new NotImplementedException();
        }
    }
}
