﻿using System;
using System.Collections.Generic;
using System.Text;
using SharpMap.Geometries;

namespace Ogc.Filter.SpatialOps
{

    public enum DistanceOpType
    {
        DWithin, Beyond
    }

    public class DistanceBuffer : SpatialOp
    {
        Geometry geometry;
        public Geometry Geometry
        {
            get { return geometry; }
            set { geometry = value; }
        }

        double distance;
        DistanceOpType opType;

        public DistanceBuffer(string geoPropertyName, Geometry geometry, DistanceOpType opType, double distance)
            : base(geoPropertyName)
        {
            this.geometry = geometry;
            this.opType = opType;
            this.distance = distance;
        }

        protected override bool Test(IGeomeryPropertyGetter getter)
        {
            if (opType == DistanceOpType.DWithin)
                return getter.GetGeometryProperty(GeoPropertyName).Distance(geometry) <= distance;
            if (opType == DistanceOpType.Beyond)
                return getter.GetGeometryProperty(GeoPropertyName).Distance(geometry) > distance;
            throw new Exception();
        }
    }

}
