﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing;
using SharpMap.Geometries;
using SharpMap.Rendering;

namespace Ogc.Sld.Symbolizers
{
    public class PolygonSymbolizer : Symbolizer
    {
        Pen stroke;
        public System.Drawing.Pen Stroke
        {
            get { return stroke; }
            set { stroke = value; }
        }

        Brush fill;
        public System.Drawing.Brush Fill
        {
            get { return fill; }
            set { fill = value; }
        }

        public override void Render(Graphics g, SharpMap.Map map, SharpMap.Data.FeatureDataRow dr)
        {
            if (dr.Geometry is Polygon)
                VectorRenderer.DrawPolygon(g, (Polygon)dr.Geometry, fill, stroke, false, map);
            else if (dr.Geometry is MultiPolygon)
                VectorRenderer.DrawMultiPolygon(g, (MultiPolygon)dr.Geometry, fill, stroke, false, map);
        }
    }
}
