﻿using System;
using System.Collections.Generic;
using System.Text;
using SharpMap.Rendering;
using System.Drawing;

namespace Ogc.Sld.Symbolizers
{
    public class TextSymbolizer : Symbolizer
    {
        Font font;
        public Font Font
        {
            get { return font; }
            set { font = value; }
        }

        string propertyName;
        public TextSymbolizer(string propertyName)
        {
            this.propertyName = propertyName;
            this.font = System.Drawing.SystemFonts.DefaultFont;
        }

        public override void Render(System.Drawing.Graphics g, SharpMap.Map map, SharpMap.Data.FeatureDataRow dr)
        {
            SharpMap.Geometries.Point pt =  dr.Geometry.GetBoundingBox().GetCentroid();
            System.Drawing.PointF lpt = map.WorldToImage(pt);
            VectorRenderer.DrawLabel(g, lpt
                , new System.Drawing.PointF()
                , font
                , System.Drawing.Color.Black
                , System.Drawing.Brushes.White
                , null, 0, dr[propertyName].ToString()
                , map);
        }
    }
}
