﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Net;
using System.Xml;
using System.Drawing;
using System.IO;

namespace Ogc.Wms
{
    public class Client
    {
        string uri;
        public Client(string uri)
        {
            this.uri = uri;
        }

        string version = "1.1.1";
        public string Version
        {
            get { return version; }
            set { version = value; }
        }

        string service = "WMS";
        public string Service
        {
            get { return service; }
            set { service = value; }
        }

        public Capabilities GetCapabilities()
        {
            System.UriBuilder uriBuilder = new System.UriBuilder(uri);
            uriBuilder.Query = Uri("GetCapabilities");
            System.Net.WebRequest wr = System.Net.WebRequest.Create(uriBuilder.Uri);
            using (System.Net.WebResponse response = wr.GetResponse())
            {
                XmlDocument doc = new XmlDocument();
                doc.Load(response.GetResponseStream());
                return Factory.Create<Capabilities>(doc.DocumentElement);
            }
        }

        public System.Drawing.Bitmap GetMap(string p)
        {
            System.UriBuilder uriBuilder = new System.UriBuilder(uri);
            uriBuilder.Query = Uri("GetMap") + "&" + p;
            System.Net.WebRequest wr = System.Net.WebRequest.Create(uriBuilder.Uri);
            using (System.Net.WebResponse response = wr.GetResponse())
            {
                return (Bitmap)Bitmap.FromStream(response.GetResponseStream());
            }
        }

        private string Uri(string method)
        {
            return string.Format("VERSION={0}&SERVICE={1}&REQUEST={2}", version, service, method);
        }
    }
}
