﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Xml;

namespace Ogc.Wms
{
    public class Layer : NamedModel
    {
        Layer parent;

        public Layer(XmlElement dataNode, Layer parent)
        {
            this.dataNode = dataNode;
            this.parent = parent;
        }

        public Layer(XmlElement dataNode)
            : this(dataNode, null)
        {
        }

        public bool Queryable
        {
            get
            {
                int ret;
                if (int.TryParse(dataNode.SelectSingleNode("@queryable").Value, out ret))
                    return ret == 1;
                return true;
            }
            set
            {
                SetAttr("queryable", value ? "1" : "0");
            }
        }

        public Style AddStyle()
        {
            return CreateChild<Style>();
        }

        public Style[] Styles
        {
            get
            {
                return GetChildren<Style>();
            }
        }

        public Layer AddLayer()
        {
            return CreateChild<Layer>();
        }

        public Layer AddLayerDup(XmlElement data)
        {
            Layer ret = CreateChild<Layer>();
            ret.DataNode.InnerXml = data.InnerXml;
            return ret;
        }

        public Layer[] Layers
        {
            get
            {
                return GetChildren<Layer>();
            }
        }

        public void AddSrs(string value)
        {
            AddNodeInnerText("SRS", value);
        }

        public string[] Srss
        {
            get
            {
                return GetTextArray("./SRS");
            }
        }

        public LatLonBoundingBox CreateLatLonBoundingBox()
        {
            return CreateChild<LatLonBoundingBox>();
        }

        public LatLonBoundingBox LatLonBoundingBox
        {
            get
            {
                return GetChild<LatLonBoundingBox>();
            }
        }

        public BoundingBox AddBoundingBox()
        {
            return CreateChild<BoundingBox>();
        }

        public BoundingBox[] BoundingBoxs
        {
            get
            {
                return GetChildren<BoundingBox>();
            }
        }
    }
}
