﻿using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.IO;

/// <summary>
/// Config 的摘要说明
/// </summary>
public class Config
{
    public static string GetWmsLayersPath()
    {
        string path = Path.Combine(AppDomain.CurrentDomain.BaseDirectory, "App_Data\\"
                + ConfigurationManager.AppSettings["data_path_layers"]);
        if (!Directory.Exists(path))
            throw new DirectoryNotFoundException(path);
        return path;
    }

    public static string GetWmsLayerFile(string layerName)
    {
        return Path.Combine(GetWmsLayersPath(), layerName + ".xml");
    }

    public static string GetSridFile()
    {
        return Path.Combine(AppDomain.CurrentDomain.BaseDirectory, "App_Data\\SRID.csv");
    }

    public static string GetStyleFile(string name)
    {
        string path = Path.Combine(AppDomain.CurrentDomain.BaseDirectory, "App_Data\\"
                + ConfigurationManager.AppSettings["data_path_style"] + "\\" + name + ".xml");
        if (!File.Exists(path))
            throw new FileNotFoundException(path);
        return path;
    }

    public static string GetEsriShapeFile(string layerName)
    {
        return Path.Combine(AppDomain.CurrentDomain.BaseDirectory, "App_Data\\"
                        + ConfigurationManager.AppSettings["data_path_layer_esri_shape"] + "\\" + layerName);
    }

    public static string GetSldFile(string styleName)
    {
        string stf = Path.Combine(AppDomain.CurrentDomain.BaseDirectory, "App_Data\\"
                + ConfigurationManager.AppSettings["data_path_style_sld"] + "\\" + styleName + ".xml");
        if (!File.Exists(stf))
            throw new FileNotFoundException("文件没找到", stf);
        return stf;
    }

    public static string GetWktFile(string wkn)
    {
        string wkf = Path.Combine(AppDomain.CurrentDomain.BaseDirectory, "App_Data\\"
                + ConfigurationManager.AppSettings["data_path_well_known_symbol"] + "\\" + wkn);
        if (!File.Exists(wkf))
            throw new FileNotFoundException("文件没找到", wkf);
        return wkf;
    }

    public static string GetDataProviderFile(string layerName)
    {
        string ret = Path.Combine(AppDomain.CurrentDomain.BaseDirectory, "App_Data\\"
                + ConfigurationManager.AppSettings["data_path_data_source"] + "\\" + layerName + ".xml");
        if (!File.Exists(ret))
            throw new FileNotFoundException("文件没找到", ret);
        return ret;
    }

    public static string[] GetWmsLayerFiles()
    {
        return Directory.GetFiles(Config.GetWmsLayersPath(), "*.xml");
    }

}
