﻿using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Ogc.Sld;
using System.Drawing.Drawing2D;
using System.Drawing;
using System.IO;

/// <summary>
/// WellKnownSymbol 的摘要说明
/// </summary>
public class WellKnownSymbol : IWellKnownSymbolGetter
{
    public WellKnownSymbol()
    {
        //
        // TODO: 在此处添加构造函数逻辑
        //
    }

    private GraphicsPath GetWellKnownSymbol(string wkn)
    {
        string wkf = Config.GetWktFile(wkn + ".txt");
        if (!File.Exists(wkf))
            return null;

        string[] ls = File.ReadAllLines(wkf);
        if (ls.Length < 1)
            throw new InvalidDataException();
        if (ls[0].Equals("Ellipse", StringComparison.OrdinalIgnoreCase))
            return BuildEllipsePath(ls);
        if (ls[0].Equals("Vertex", StringComparison.OrdinalIgnoreCase))
            return BuildVertexPath(ls);
        throw new NotImplementedException();
    }

    private GraphicsPath BuildVertexPath(string[] ls)
    {
        if (ls.Length < 5)
            throw new InvalidDataException();

        PointF[] vers = new PointF[ls.Length - 1];
        for (int i = 1; i < ls.Length; ++i)
        {
            vers[i - 1] = ParsePoint(ls[i]);
        }
        GraphicsPath ret = new GraphicsPath();
        ret.AddLines(vers);
        return ret;
    }

    private PointF ParsePoint(string s)
    {
        string[] ss = s.Split(',');
        if (ss.Length != 2)
            throw new InvalidDataException();
        return new PointF(float.Parse(ss[0]), float.Parse(ss[1]));
    }

    private GraphicsPath BuildEllipsePath(string[] ls)
    {
        GraphicsPath ret = new GraphicsPath();
        ret.AddEllipse(0, 0, 1, 1);
        return ret;
    }

    #region IWellKnownSymbolGetter 成员

    public System.Drawing.Drawing2D.GraphicsPath GetSymbol(string wkn)
    {
        return GetWellKnownSymbol(wkn);
    }

    #endregion
}
