﻿using System;
using System.Collections.Generic;
using System.Text;
using NUnit.Framework;
using Ogc.Filter.SpatialOps;
using SharpMap.Geometries;

namespace unittests.Ogc.Filter
{
    [TestFixture]
    public class SpatialOpTests
    {
        [Test]
        public void TestBBox()
        {
            NamedGeomeryPropertyGetter getter = new NamedGeomeryPropertyGetter();
            getter.Add("the_geom", new Polygon(new LinearRing(new List<Point>(
                new Point[] { 
                    new Point(.2,.3),
                    new Point(.5,1.7),
                    new Point(1.9,.4),
                    new Point(.2,.3),
                }
                ))));

            Assert.IsTrue(new BBox("the_geom", new BoundingBox(0, 0, 1, 1)).Test(getter));
            Assert.IsFalse(new BBox("the_geom", new BoundingBox(2, 0, 3, 1)).Test(getter));
        }


    }
}
